local isme, istarget = _G.COMBATLOG_OBJECT_AFFILIATION_MINE, _G.COMBATLOG_OBJECT_TARGET;
local bband, mceil = bit.band, math.ceil;

local self_guid = nil;

--change this line for you local client language
local L_OVERWHELM, L_REND_FLESH = 'Overwhelm', 'Rend Flesh';

--change these to modify where the icon appears in relation to the center of the screen 0, 0 would be the exact middle
local RIGHT, TOP = 0, 80;

local FONT = "Fonts\\FRIZQT__.ttf";

local UnitGUID, UnitClass, UnitHealthMax, select = UnitGUID, UnitClass, UnitHealthMax, select;

local cUrsoc = CreateFrame("Frame", "cUrsoc", UIParent);
cUrsoc:SetWidth(60);
cUrsoc:SetHeight(60);
cUrsoc:SetPoint("CENTER", UIParent, "CENTER", RIGHT, TOP);

--Animation frame
local texture = cUrsoc:CreateTexture(nil, "BAKCGROUND");
texture:SetAllPoints(cUrsoc);

local group = cUrsoc:CreateAnimationGroup();
group:SetLooping("NONE")
group:SetScript("OnFinished", function()
	cUrsoc:SetAlpha(0)
end)
--group:SetIgnoreFramerateThrottle(true)

cUrsoc:RegisterEvent("ADDON_LOADED");

cUrsoc:SetScript("OnEvent", function(self, event, ...)
	self[event](self, ...)
end);

local function taunt()
	--Ping
	PlaySoundFile('Interface\\AddOns\\cUrsoc\\media\\sonar.ogg');

	--Fire the animation
	group:Stop();
	texture:SetTexture([[Interface\Icons\spell_nature_reincarnation]]);
	group:Play();
end;

SLASH_CURSOC1 = "/ursoc"
SlashCmdList["CURSOC"] = function(m, e)
	taunt()
end;

function cUrsoc:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, hideCaster, srcGUID, srcName, srcFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, a1, a2, a3, a4)
	--a1 is spellid, a2 spellname for SPELL_ events, 221770 is Fleshrending from Ursoc's Rending Paw which applies the same debuff :<
	if(event ~= 'SPELL_AURA_REMOVED' and event ~= 'SPELL_AURA_APPLIED' and event ~= 'SPELL_AURA_APPLIED_DOSE') then return; end;
	if((a2 ~= L_REND_FLESH and a2 ~= L_OVERWHELM) or a1 == 221770) then return; end;

	if(event == 'SPELL_AURA_REMOVED' and destGUID == self_guid) then
		--when 'you' lose Overwhelm or Rend
		taunt();
	elseif(destGUID ~= self_guid and (event == 'SPELL_AURA_APPLIED' or event == 'SPELL_AURA_APPLIED_DOSE')) then
		local current, ignore = nil, false;
		--when 'other' gains Overwhelm or Rend

		if(a2 == L_OVERWHELM) then
			current = UnitDebuff('player', L_OVERWHELM);

			--wait for your overwhelm / rend flesh to fade first
			if(current == L_OVERWHELM) then
				ignore = true;
			else
				current = UnitDebuff('player', L_REND_FLESH);

				if(current == L_REND_FLESH) then
					ignore = true;
				end;
			end;
		end;

		if(not ignore) then
			taunt();
		end;
	end;
end;

function cUrsoc:PLAYER_REGEN_ENABLED()
	cUrsoc:UnregisterEvent('COMBAT_LOG_EVENT_UNFILTERED');
end;

function cUrsoc:PLAYER_REGEN_DISABLED()
	if self_guid == nil then self_guid = UnitGUID('player'); end;

	--check that UnitName('boss1') is Ursoc
	cUrsoc:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED');
end;

function cUrsoc:ADDON_LOADED(v)
	if(v ~= 'cUrsoc') then return end;

	self_guid = UnitGUID('player');

	--setup the animation duration
	local aX = group:CreateAnimation("Alpha");
	--aX:SetEndDelay(1.25);
	aX:SetDuration(0.5);
	aX:SetFromAlpha(0);
	aX:SetToAlpha(1);
	aX = group:CreateAnimation("Alpha")
	aX:SetStartDelay(1.5);
	--aX:SetEndDelay(0.25);
	aX:SetDuration(1.25);
	aX:SetFromAlpha(1);
	aX:SetToAlpha(0);

	cUrsoc:RegisterEvent('PLAYER_REGEN_ENABLED');
	cUrsoc:RegisterEvent('PLAYER_REGEN_DISABLED');
end;